############
#Objective
############
#This function is to 
#1.Scale the count data (count data only) to proportion
#2.create a data frame consisting of proportion data, and 
#enviromental data (host genome and other information about observations)

#3. Keep an variable name list (original variable names and names in terms of X's, e.g.X1,X2,..,etc. )
#This name list is to retrieve the original variable names of the final selected variables



##########
#INPUTS:
##########
#X.c: data frame that has count data from all levels (only count data will be row scaled)
 
#X.o: data frame that has other enviromental variables  
#(no scaling will be done, those variables will scaled together with proportion data in LASSO step)

#y: a vector representing the binary status 0 or 1


##########
#OUTPUTS
##########
#name.List: a dataframe containing the orignal variable names and new names in terms of X (X1,X2,...Xp)

#data: a dataframe containing all variables named as X1,X2,...,Xp and the binary outcome (called status)in the last column
       #this data frame will be used in the other functions for data analysis 



dataclean<-function(X.c,X.o,y){
  
  if(length(X.c)!=0)X.c=X.c/apply(X.c,1,sum) # rowscale the count data
  #p.c=dim(X.c)[2]
  if(length(X.o)==0&length(X.c)!=0)X=data.frame(X.c) 
  if(length(X.o)==0&length(X.c)==0)stop("No predictor variables given")
  if(length(X.o)!=0&length(X.c)==0)X=data.frame(X.o) 
  if(length(X.o)!=0&length(X.c)!=0)X=data.frame(X.c,X.o)



#  varname=colnames(X)
#  colnames(X)=NULL
#  colnames(X)=colnames(X,do.NULL = FALSE,prefix="X")
#  varname.new=colnames(X)
#  name.List=data.frame(varname,varname.new) # list consisting of old and new variable names
  
  
  Data.Xy=data.frame(X,y) # data frame that has all X's and y (status)
  
  return(Data.Xy)#list(varnameList=name.List,data=Data.Xy))  
}





